#ifndef COLLISION_DEFINE
#define COLLISION_DEFINE

/*
atanks - obliterate each other with oversize weapons
Copyright (C) 2003  Thomas Hudson

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


#include "main.h"

class COLLISION_MESH
{
	private:
	GLOBALDATA *_global;
	ENVIRONMENT *_env;

	public:
	VECTOR	centreOfMass;
	VECTOR	*points;
	VECTOR	*normals;
	int	numPoints;

	COLLISION_MESH (GLOBALDATA *global, ENVIRONMENT *env);
	COLLISION_MESH (GLOBALDATA *global, ENVIRONMENT *env, int radius);
	COLLISION_MESH (GLOBALDATA *global, ENVIRONMENT *env, BITMAP *bitmap);

	VECTOR	setupCollisionPoints ();
	VECTOR	setupCollisionPoints (int radius);
	VECTOR	setupCollisionPoints (BITMAP *bitmap);
	VECTOR	calcCentreOfMass (BITMAP *bitmap);
	int	pointCollisionTest (VECTOR point, BITMAP *bitmap, VECTOR location, int rotation);
	VECTOR	collisionTest (BITMAP *bitmap, VECTOR location, int rotation);
};

#endif
