
enum tokenTypes {
	TOKENTYPE_NONE,
	TOKENTYPE_KEYWORD,
	TOKENTYPE_STRING,
	TOKENTYPE_INT,
	TOKENTYPE_DOUBLE,
	TOKENTYPE_ENUM,
	TOKENTYPE_BITMAP,
	TOKENTYPE_TERMINATOR
};

typedef struct enumConversion {
	char	*define;
	int	number;
} ENUM_CONVERSION;

typedef struct parserToken {
	char		*token;
	tokenTypes	type;
	int		offset;	// offset in structure
	int		structSize;
	ENUM_CONVERSION	*conversion;
	struct configSection	*config;
} PARSER_TOKEN;

typedef struct configSection {
	char	*name;
	void	**dest;
	int	numEntries;
	int	destSize;
	int	structSize;
	PARSER_TOKEN	*parserTokens;
} CONFIG_SECTION;

int parseTokens (FILE *file, CONFIG_SECTION *config);

extern PARSER_TOKEN topLevelParserTokens[];
extern PARSER_TOKEN weaponParserTokens[];
extern CONFIG_SECTION topLevelConfigSection;
extern CONFIG_SECTION weaponConfigSection;
extern CONFIG_SECTION naturalsConfigSection;
