#ifndef	PHYSOBJ_DEFINE
#define	PHYSOBJ_DEFINE

/*
 * atanks - obliterate each other with oversize weapons
 * Copyright (C) 2003  Thomas Hudson
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * */


#include "main.h"
#include "virtobj.h"

class PHYSICAL_OBJECT: public VIRTUAL_OBJECT
{
	public:
	triggerTypes	trigger;
	angleTypes	angleType;
	repelTypes	repelType;
	physicsTypes	physicsType;
	gravityTypes	gravityType;
	subterraneanTypes	subterraneanType;
	int		detonate;
	int		hitSomething;
	int		repulsion;
	double		mass;
	double		drag;
	double		spin;
	double		inertia;
	double		objRadius;
	double		elasticity;

	virtual	~PHYSICAL_OBJECT () {};
	int	applyPhysics ();
	void	repulse (double xpos, double ypos, double *xaccel, double *yaccel);
	int	scanLeadingArc (int spokeStart, int spokeStop, int spokeStep);
	int	checkPixelsBetweenPrevAndNow ();
	void	initialise ();
	void	draw (BITMAP *dest) {VIRTUAL_OBJECT::draw (dest);};
	virtual int	isSubClass (int classNum) = 0;
};

#endif
